 * ------------------------------------------------ ;
 * -- PSI MODULE DIAGNOSIS AND PROCEDURE MACROS --- ;
 *  VERSION: AHRQ QI v7.0.1 BETA
 *  RELEASE DATE: DECEMBER 2017
 * ------------------------------------------------ ;

 *DESCRIPTION: Assigns diagnosis and procedure macros called by other SAS programs.
              The user does not need to open.;

 /*Macro to compare all discharge diagnosis codes against format.*/
 %MACRO MDX(FMT);

 (%DO I = 1 %TO &NDX.-1;
  (put(DX&I.,&FMT.) = '1') or
  %END;
  (put(DX&NDX.,&FMT.) = '1'))

 %MEND;

 /*Macro to compare discharge primary diagnosis code against format.*/
 %MACRO MDX1(FMT);

 (put(DX1,&FMT.) = '1')

 %MEND;
 /*Macro to compare discharge secondary diagnosis codes against format.*/
 %MACRO MDX2(FMT);

 (%DO I = 2 %TO &NDX.-1;
  (put(DX&I.,&FMT.) = '1') or
  %END;
  (put(DX&NDX.,&FMT.) = '1'))

 %MEND;
/*Macro to determine if measure format diagnosis is included in any secondary discharge diagnosis code as not present on admission.*/

 %MACRO MDX2Q1(FMT);

 (%DO I = 2 %TO &NDX.-1;
  ((put(DX&I.,$poaxmpt_v34fmt.)='0' and put(DX&I.,&FMT.) = '1' and DXPOA&I. in ('N','U',' ','E','1','X') and ICDVER = 34) or
  (put(DX&I.,$poaxmpt_v33fmt.)='0' and put(DX&I.,&FMT.) = '1' and DXPOA&I. in ('N','U',' ','E','1','X') and ICDVER = 33)) or
  %END;
  ((put(DX&I.,$poaxmpt_v34fmt.)='0' and put(DX&I.,&FMT.) = '1' and DXPOA&I. in ('N','U',' ','E','1','X') and ICDVER = 34) or
  (put(DX&I.,$poaxmpt_v33fmt.)='0' and put(DX&I.,&FMT.) = '1' and DXPOA&I. in ('N','U',' ','E','1','X') and ICDVER = 33)))

 %MEND;
/*Macro to determine if measure format diagnosis is included in any secondary discharge diagnosis code as present on admission.*/
  %MACRO MDX2Q2(FMT);
 (
%DO I = 2 %TO &NDX.-1;
( (PUT(DX&I.,$poaxmpt_v34fmt.)='0' AND PUT(DX&I.,&FMT.) = '1' AND DXPOA&I. IN ('Y','W') AND ICDVER = 34) OR (PUT(DX&I.,$poaxmpt_v34fmt.)='1' AND PUT(DX&I.,&FMT.) = '1' AND ICDVER = 34) ) OR
( (PUT(DX&I.,$poaxmpt_v33fmt.)='0' AND PUT(DX&I.,&FMT.) = '1' AND DXPOA&I. IN ('Y','W') AND ICDVER = 33) OR (PUT(DX&I.,$poaxmpt_v33fmt.)='1' AND PUT(DX&I.,&FMT.) = '1' AND ICDVER = 33) ) OR

  %END;
((PUT(DX&NDX.,$poaxmpt_v34fmt.)='0' AND PUT(DX&NDX.,&FMT.) = '1' AND DXPOA&NDX. IN ('Y','W') AND ICDVER = 34) OR (PUT(DX&NDX.,$poaxmpt_v34fmt.)='1' AND PUT(DX&NDX.,&FMT.) = '1' AND ICDVER = 34) ) OR
((PUT(DX&NDX.,$poaxmpt_v33fmt.)='0' AND PUT(DX&NDX.,&FMT.) = '1' AND DXPOA&NDX. IN ('Y','W') AND ICDVER = 33) OR (PUT(DX&NDX.,$poaxmpt_v33fmt.)='1' AND PUT(DX&NDX.,&FMT.) = '1' AND ICDVER = 33) )
)
 %MEND;
/*Macro to determine if measure format diagnosis is included in any discharge diagnosis code as present on admission.*/
  %MACRO MDXAQ2(FMT);
 (
%DO I = 1 %TO &NDX.-1;
( (PUT(DX&I.,$poaxmpt_v34fmt.)='0' AND PUT(DX&I.,&FMT.) = '1' AND DXPOA&I. IN ('Y','W') AND ICDVER = 34) OR (PUT(DX&I.,$poaxmpt_v34fmt.)='1' AND PUT(DX&I.,&FMT.) = '1' AND ICDVER = 34) ) OR
( (PUT(DX&I.,$poaxmpt_v33fmt.)='0' AND PUT(DX&I.,&FMT.) = '1' AND DXPOA&I. IN ('Y','W') AND ICDVER = 33) OR (PUT(DX&I.,$poaxmpt_v33fmt.)='1' AND PUT(DX&I.,&FMT.) = '1' AND ICDVER = 33) ) OR

  %END;
((PUT(DX&NDX.,$poaxmpt_v34fmt.)='0' AND PUT(DX&NDX.,&FMT.) = '1' AND DXPOA&NDX. IN ('Y','W') AND ICDVER = 34) OR (PUT(DX&NDX.,$poaxmpt_v34fmt.)='1' AND PUT(DX&NDX.,&FMT.) = '1' AND ICDVER = 34) ) OR
((PUT(DX&NDX.,$poaxmpt_v33fmt.)='0' AND PUT(DX&NDX.,&FMT.) = '1' AND DXPOA&NDX. IN ('Y','W') AND ICDVER = 33) OR (PUT(DX&NDX.,$poaxmpt_v33fmt.)='1' AND PUT(DX&NDX.,&FMT.) = '1' AND ICDVER = 33) )
)
 %MEND;
 /*Macro to compare discharge DRG code against format.*/
 %MACRO MDR(FMT);

 (put(put(DRG,Z3.),&FMT.) = '1')

 %MEND;
  /*Macro to compare all discharge procedure codes against format.*/
 %MACRO MPR(FMT);

 (%DO I = 1 %TO &NPR.-1;
  (put(PR&I.,&FMT.) = '1') or
  %END;
  (put(PR&NPR.,&FMT.) = '1'))

 %MEND;
/*Macro to compare first discharge procedure code against format.*/
 %MACRO MPR1(FMT);

 (put(PR1,&FMT.) = '1')

 %MEND;
/*Macro to compare secondary discharge procedure codes against format.*/
 %MACRO MPR2(FMT);

 (%DO I = 2 %TO &NPR.-1;
  (put(PR&I.,&FMT.) = '1') or
  %END;
  (put(PR&NPR.,&FMT.) = '1'))

 %MEND;
/*Macro to compare discharge procedure codes against measure format and operating room format and count total.*/

 %MACRO MPRCNT(FMT);

    MPRCNT = 0; 
    %DO I = 1 %TO &NPR.;
       if put(PR&I.,&FMT.) = '1'    AND
          put(PR&I.,$ORPROC.) = '1' then MPRCNT + 1;
    %END;

 %MEND;
/*Macro to return the first day a measure format procedure was conducted based on PRDAY.*/
 %MACRO MPRDAY(FMT);

    MPRDAY = .;
    %DO I = 1 %TO &NPR.;
       if put(PR&I.,&FMT.) = '1' and PRDAY&I. GT .Z then do;
          if MPRDAY LE .Z then MPRDAY = PRDAY&I;
          else if MPRDAY > PRDAY&I. then MPRDAY = PRDAY&I;
       end;
    %END;

 %MEND;
/*Macro to count the number of procedures on the discharge that are operating room procedures.*/

%MACRO ORCNT;

    ORCNT = 0;
    %DO I = 1 %TO &NPR.;
       if put(PR&I.,$ORPROC.) = '1' then ORCNT + 1;
    %END;

%MEND;
/*Macro to return first day an operating room procedure was conducted that was not the measure format based on PRDAY.*/
%MACRO ORDAY(FMT);

    ORDAY = .;
    %DO I = 1 %TO &NPR.;
       if put(PR&I.,$ORPROC.) = '1' and
          put(PR&I.,&FMT.)    = '0' then do;
          if PRDAY&I. GT .Z then do;
             if ORDAY = . then ORDAY = PRDAY&I;
             else if ORDAY > PRDAY&I. then ORDAY = PRDAY&I;
          end;
       end;
    %END;

%MEND;
 /*Macro to add PRDAY fields onto input statement based on Control file setting.*/
 %MACRO ADDPRDAY; 
    %IF &PRDAY EQ 1 %THEN PRDAY1-PRDAY&NPR. ;
 %MEND;
